/**********************************************************************
 * LeechCraft - modular cross-platform feature rich internet client.
 * Copyright (C) 2006-2012  Georg Rudoy
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **********************************************************************/

#pragma once

#include <QObject>

class QAbstractItemModel;
class QStandardItemModel;

namespace LeechCraft
{
namespace LMP
{
	class IUnmountableSync;
	struct UnmountableDevInfo;

	class UnmountableDevManager : public QObject
	{
		Q_OBJECT

		QStandardItemModel *DevListModel_;
		QObjectList Managers_;

		enum Roles
		{
			DeviceID = Qt::UserRole + 1,
			DeviceInfo,
			ManagerObj
		};
	public:
		UnmountableDevManager (QObject* = 0);

		QAbstractItemModel* GetDevListModel () const;
		void InitializePlugins ();

		QObject* GetDeviceManager (int) const;
		UnmountableDevInfo GetDeviceInfo (int) const;
	private slots:
		void rebuildAvailableDevices ();
	};
}
}
