# Find Qross library

#
# QROSS_INCLUDE_DIR
# QROSS_LIBRARIES
# QROSS_FOUND

# Copyright (c) 2011 Georg Rudoy <0xd34df00d@gmail.com>

IF(QROSS_LIBRARIES AND QROSS_INCLUDE_DIR)
	SET(QROSS_FOUND 1)
ELSE(QROSS_LIBRARIES AND QROSS_INCLUDE_DIR)
	FIND_PATH(QROSS_INCLUDE_DIR qross/core/manager.h PATH ENV)
	FIND_LIBRARY(QROSS_LIBRARIES NAMES qrosscore)

	IF(QROSS_LIBRARIES AND QROSS_INCLUDE_DIR)
		SET(QROSS_FOUND 1)
	ENDIF(QROSS_LIBRARIES AND QROSS_INCLUDE_DIR)
ENDIF(QROSS_LIBRARIES AND QROSS_INCLUDE_DIR)

IF(QROSS_FOUND)
	MESSAGE(STATUS "Found Qross libraries at ${QROSS_LIBRARIES}")
	MESSAGE(STATUS "Found Qross headers at ${QROSS_INCLUDE_DIR}")
ELSE(QROSS_FOUND)
	IF(QROSS_FIND_REQUIRED)
		MESSAGE(FATAL_ERROR "Could NOT find required Qross library, aborting")
	ELSE()
		MESSAGE(STATUS "Could NOT find Qross")
	ENDIF()
ENDIF()
